package com.me.asteroids;

import com.badlogic.gdx.math.MathUtils;
import com.badlogic.gdx.math.Vector2;

public final class Utils {

    private static final Vector2 tmp = new Vector2();

    public static float rotate(float rotation, float degrees) {
        return wrapAngle(rotation + degrees);
    }

    public static float wrapAngle(float degrees) {
        if (degrees < 0)
            return degrees + 360;
        else if (degrees > 360)
            return degrees - 360;
        return degrees;
    }

    public static Vector2 setUnitVectorAngle(Vector2 vector, float degrees) {
        return vector.set((float) Math.cos(degrees * MathUtils.degreesToRadians), (float) Math.sin(degrees * MathUtils.degreesToRadians));
    }

    public static Vector2 setUnitVectorAngleRad(Vector2 vector, float radians) {
        return vector.set((float) Math.cos(radians), (float) Math.sin(radians));
    }

    public static Vector2 getPointAlongPolygon(Vector2[] vertices, float distanceAlongPerimeter) {
        for (int i = 0, n = vertices.length; i < n; i++) {
            Vector2 a = vertices[i];
            Vector2 b = vertices[i + 1 == n ? 0 : i + 1];
            tmp.set(a).sub(b);
            float len = tmp.len();

            if (len < distanceAlongPerimeter) {
                distanceAlongPerimeter -= len;
                continue;
            }

            return a.add(tmp.set(tmp.x / len, tmp.y / len).scl(distanceAlongPerimeter));
        }
        return null;
    }

}
