package com.me.asteroids.components;

import com.badlogic.gdx.graphics.Color;
import com.badlogic.gdx.graphics.glutils.ShapeRenderer;
import com.badlogic.gdx.math.Rectangle;
import com.badlogic.gdx.math.Vector2;
import com.me.asteroids.components.model.Model;
import com.me.common.ecs.Component;

public class ModelComponent implements Component {

    public Model model;

    public ModelComponent(Model model) {
        this.model = model;
    }

    public Color getColor() {
        return model.getColor();
    }

    public ModelComponent setVertices(float[] vertices) {
        model.setVertices(vertices);
        return this;
    }

    public float[] getVertices() {
        return model.getVertices();
    }

    public ModelComponent setPosition(Vector2 position) {
        model.setPosition(position);
        return this;
    }

    public Vector2 getPosition() {
        return model.getPosition();
    }

    public ModelComponent setRotation(float degrees) {
        model.setRotation(degrees);
        return this;
    }

    public float getRotation() {
        return model.getRotation();
    }

    public ModelComponent setScale(float scale) {
        model.setScale(scale);
        return this;
    }

    public float getScale() {
        return model.getScale();
    }

    public Rectangle getBoundingBox() {
        return model.getBoundingBox();
    }

}
