package com.me.asteroids.systems;

import com.badlogic.gdx.graphics.glutils.ShapeRenderer;
import com.me.asteroids.Graphics;
import com.me.asteroids.components.ModelComponent;
import com.me.asteroids.components.model.Model;
import com.me.common.ecs.Engine;
import com.me.common.ecs.Entity;
import com.me.common.ecs.EntitySystem;

import static com.me.asteroids.Components.MODEL;

public class ModelRenderSystem extends EntitySystem {

    private ShapeRenderer renderer;

    public ModelRenderSystem(Engine engine, Graphics graphics) {
        super(engine, ModelComponent.class);
        this.renderer = graphics.getShapeRenderer();
    }

    @Override
    public void preProcess() {
        renderer.begin(ShapeRenderer.ShapeType.Line);
    }

    @Override
    public void processEntity(Entity entity, float dt) {
        Model model = MODEL.get(entity).model;

        renderer.setColor(model.getColor());
        model.render(renderer);
    }

    @Override
    public void postProcess() {
        renderer.end();
    }

}
